 # -*- coding: utf-8 -*-
import math
import glob

def clamp(val, minimum, maximum):
    return max(minimum, min(val, maximum))

def ompy_params(d):
    d.floatDescs[0].name = 'Index'
    d.floatDescs[1].name = 'Opacity'

    #
def ompy_main(c):
    ctx = c.layer_out_context

    width, height = c.width, c.height
    ratio = float(width) / height

    images = glob.glob('/ompy/ompy22/*.png')
    index = int(c.floats[0]) % len(images)
    image = images[index]

    surface = cairo.ImageSurface.create_from_png(image)

    image_width, image_height = surface.get_width(), surface.get_height()
    image_ratio = float(image_width) / image_height

    if image_ratio > ratio:
        scale = float(width) / image_width
        x = 0
        y = 0.5 * (height / scale - image_height)
    else:
        scale = float(height) / image_height
        x = 0.5 * (width / scale - image_width)
        y = 0

    opacity = clamp(c.floats[1] * 0.01, 0.0, 1.0)
    
    ctx.scale(scale, scale)
    ctx.translate(x, y)
    ctx.set_source_surface(surface)
    ctx.paint_with_alpha(opacity)
